Package com.smartgwt.client.widgets.form.fields

# Class MiniDateRangeItem

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.core.RefDataClass
com.smartgwt.client.data.Field
com.smartgwt.client.widgets.form.fields.FormItem
com.smartgwt.client.widgets.form.fields.StaticTextItem
com.smartgwt.client.widgets.form.fields.MiniDateRangeItem

All Implemented Interfaces:
  `HasHandlers`, `HasBlurHandlers`, `HasChangedHandlers`, `HasChangeHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasEditorEnterHandlers`, `HasEditorExitHandlers`, `HasFocusHandlers`, `HasIconClickHandlers`, `HasIconKeyPressHandlers`, `HasItemHoverHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasKeyUpHandlers`, `HasPendingStatusChangedHandlers`, `HasPickerIconClickHandlers`, `HasShowContextMenuHandlers`, `HasTitleClickHandlers`, `HasTitleDoubleClickHandlers`, `HasTitleHoverHandlers`, `HasValueHoverHandlers`, `HasValueIconClickHandlers`

public class MiniDateRangeItem extends StaticTextItem
Provides a compact interface for editing a date range, by providing a formatted, read-only display of the current selected date range with an icon to launch a `DateRangeDialog` to edit the range.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

  `FormItem.CustomStateGetter, FormItem.StateCustomizer`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

  `configOnly, scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

  ### Fields inherited from class com.smartgwt.client.core.RefDataClass

  `id`

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MiniDateRangeItem()`
  `MiniDateRangeItem(JavaScriptObject jsObj)`
  `MiniDateRangeItem(String name)`
  `MiniDateRangeItem(String name, String title)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `static void`
  `changePickerIconDefaults(FormItemIcon defaults)`
  `Boolean`
  `getAllowRelativeDates()`
  Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
  `Boolean`
  `getAutoValidate()`
  If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
  `Boolean`
  `getCanFocus()`
  MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog.
  `Boolean`
  `getCanTabToIcons()`
  MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element.
  `DateDisplayFormat`
  `getDateDisplayFormat()`
  Format for displaying dates to the user.
  `Date`
  `getFromDate()`
  Initial value for the "from" date.
  `String`
  `getFromDateOnlyPrefix()`
  The text to prepend to the formatted date when only a `fromDate` is supplied.
  `static MiniDateRangeItem`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `FormItemIcon`
  `getPickerIcon()`
  Icon that launches a `DateChooser` for choosing an absolute date.
  `String`
  `getPickerIconPrompt()`
  The prompt to show when the mouse is hovered over the `pickerIcon`.
  `DateRangeDialog`
  `getRangeDialog()`
  Pop-up `DateRangeDialog` for entering a date range.
  `Boolean`
  `getShouldSaveValue()`
  Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
  `String`
  `getTextBoxStyle()`
  Base CSS class name for a form item's text box element.
  `Date`
  `getToDate()`
  Initial value for the "to" date.
  `String`
  `getToDateOnlyPrefix()`
  The text to prepend to the formatted date when only a `toDate` is supplied.
  `DateRange`
  `getValue()`
  Retrieves the current value of this dateRangeItem.
  `Boolean`
  `hasAdvancedCriteria()`
  Overridden to return true: dateRangeItems always generate AdvancedCriteria.
  `MiniDateRangeItem`
  `setAllowRelativeDates(Boolean allowRelativeDates)`
  Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
  `MiniDateRangeItem`
  `setAutoValidate(Boolean autoValidate)`
  If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
  `MiniDateRangeItem`
  `setCanFocus(Boolean canFocus)`
  MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog.
  `MiniDateRangeItem`
  `setCanTabToIcons(Boolean canTabToIcons)`
  MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element.
  `void`
  `setCriterionGetter(FormItemCriterionGetter getter)`
  The default `getCriterion()` implementation returns the Criterion entered in the fields shown in the `rangeDialog`.
  `MiniDateRangeItem`
  `setDateDisplayFormat(DateDisplayFormat dateDisplayFormat)`
  Format for displaying dates to the user.
  `static void`
  `setDefaultProperties(MiniDateRangeItem miniDateRangeItemProperties)`
  Class level method to set the default properties of this class.
  `void`
  `setFromDate(Date fromDate)`
  Initial value for the "from" date.
  `MiniDateRangeItem`
  `setFromDateOnlyPrefix(String fromDateOnlyPrefix)`
  The text to prepend to the formatted date when only a `fromDate` is supplied.
  `MiniDateRangeItem`
  `setPickerIcon(FormItemIcon pickerIcon)`
  Icon that launches a `DateChooser` for choosing an absolute date.
  `MiniDateRangeItem`
  `setPickerIconPrompt(String pickerIconPrompt)`
  The prompt to show when the mouse is hovered over the `pickerIcon`.
  `MiniDateRangeItem`
  `setShouldSaveValue(Boolean shouldSaveValue)`
  Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
  `MiniDateRangeItem`
  `setTextBoxStyle(String textBoxStyle)`
  Base CSS class name for a form item's text box element.
  `void`
  `setToDate(Date toDate)`
  Initial value for the "to" date.
  `MiniDateRangeItem`
  `setToDateOnlyPrefix(String toDateOnlyPrefix)`
  The text to prepend to the formatted date when only a `toDate` is supplied.
  `void`
  `setValue(DateRange value)`
  Sets the value for this dateRangeItem.

  ### Methods inherited from class com.smartgwt.client.widgets.form.fields.StaticTextItem

  `getApplyAlignToText, getApplyHeightToTextBox, getCanSelectText, getClipValue, getDateFormatter, getDefaultValue, getEditProxyConstructor, getEscapeHTML, getWrap, setApplyAlignToText, setApplyHeightToTextBox, setCanSelectText, setClipValue, setDateFormatter, setDefaultProperties, setEditProxyConstructor, setEscapeHTML, setWrap`

  ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

  `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIcon, addIcon, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addShowContextMenuHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, applyFormula, asSGWTComponent, blurItem, canEditCriterion, checkFormItemType, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusAfterItem, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getAlwaysShowControlBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getAutoCompleteKeywords, getBrowserInputType, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanHover, getCanvasAutoChild, getCellHeight, getCellStyle, getChangeOnKeypress, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDefaultOperator, getDeferActionConversion, getDestroyed, getDisabled, getDisabledHover, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEnableTitleClickWhenDisabled, getEndRow, getErrorIconHeight, getErrorIconProperties, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getExportFormat, getExtraControlTableCSS, getExtraTextBoxCSS, getFetchMissingValues, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFormula, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHeight, getHeightAsString, getHidden, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHeightAsString, getHoverOpacity, getHoverPersist, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWidthAsString, getIcon, getIconBaseStyle, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIcons, getIconTabPosition, getIconVAlign, getIconWidth, getID, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getLinearColSpan, getLinearColSpanAsString, getLinearEndRow, getLinearEndRowAsString, getLinearStartRow, getLinearStartRowAsString, getLinearWidth, getLinearWidthAsString, getListGrid, getLoadingDisplayValue, getLocateItemBy, getMinHintWidth, getMultiple, getMultipleValueSeparator, getName, getNullOriginalValueText, getOperator, getOptionCriteria, getOptionDataSource, getOptionDataSourceAsString, getOptionFilterContext, getOptionOperationId, getOptionTextMatchStyle, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPaletteDefaults, getPermanentlyHidden, getPicker, getPickerEscapeHTML, getPickerIcon, getPickerIcon, getPickerIconHeight, getPickerIconName, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconTabPosition, getPickerIconWidth, getPickerSnapEdge, getPickerSnapTo, getPixelHeight, getPixelWidth, getPrintReadOnlyTextBoxStyle, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyCanSelectText, getReadOnlyControlStyle, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getReadOnlyWhen, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRequiredRightTitlePrefix, getRequiredRightTitleSuffix, getRequiredTitlePrefix, getRequiredTitleSuffix, getRequiredWhen, getRightTitlePrefix, getRightTitleSuffix, getRowSpan, getSaveOnEnter, getScClassName, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowDisabledIconsOnFocus, getShowDisabledPickerIconOnFocus, getShowErrorIcon, getShowErrorIconInline, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowIconsOnFocus, getShowImageAsURL, getShowOldValueInHover, getShowOver, getShowOverIcons, getShowPending, getShowPickerIcon, getShowPickerIconOnFocus, getShowPickerOnFocus, getShowPickerOnFocusDelay, getShowRTL, getShowTitle, getShowValueIconOnly, getShowVoiceAssistIcon, getStartRow, getStaticHeight, getStopOnError, getStoreDisplayValues, getSupportsCutPasteEvents, getSuppressOptionDSFallback, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextBoxVPad, getTextFormula, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitlePrefix, getTitleStyle, getTitleSuffix, getTitleVAlign, getTooltip, getTop, getTreatEmptyAsNull, getType, getUpdateControlOnOver, getUpdatePickerIconOnOver, getUpdateTextBoxOnOver, getUseAdvancedCriteria, getUseDisabledHintStyleForReadOnly, getUseLocalDisplayFieldValue, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValueAsFloat, getValueAsInteger, getValueAsLong, getValueAsRecordList, getValueDeselectedCSSText, getValueField, getValueFieldName, getValueIconAriaRole, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getValueMap, getValueMapAsArray, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWhen, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapHintText, getWrapStaticValue, getWrapTitle, handleWarnOnEditorTypeConversion, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isAssignableFrom, isConfigOnly, isCreated, isCutEvent, isDisabled, isDrawn, isFocused, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, removeIcon, selectedRecordChanged, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setAlwaysShowControlBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setAutoCompleteKeywords, setBrowserInputType, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanEditOpaqueValues, setCanHover, setCellHeight, setCellStyle, setChangeOnKeypress, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setConfigOnly, setControlStyle, setCriteriaField, setCriterion, setCriterionSetter, setCustomStateGetter, setDataPath, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultOperator, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDeferActionConversion, setDisabled, setDisabledHover, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEnableTitleClickWhenDisabled, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconProperties, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setExportFormat, setExtraControlTableCSS, setExtraTextBoxCSS, setFetchMissingValues, setFilterLocally, setForeignDisplayField, setFormat, setFormula, setGlobalTabIndex, setHeight, setHeight, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverHeight, setHoverOpacity, setHoverPersist, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWidth, setIconBaseStyle, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconShowOnFocus, setIconVAlign, setIconWidth, setID, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLinearColSpan, setLinearColSpan, setLinearEndRow, setLinearEndRow, setLinearStartRow, setLinearStartRow, setLinearWidth, setLinearWidth, setLoadingDisplayValue, setLocateItemBy, setMinHintWidth, setMultiple, setMultipleValueSeparator, setName, setNullOriginalValueText, setNullProperty, setOperator, setOptionCriteria, setOptionDataSource, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setOptionTextMatchStyle, setOriginalValueMessage, setPermanentlyHidden, setPickerEscapeHTML, setPickerIconHeight, setPickerIconName, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPickerSnapEdge, setPickerSnapTo, setPrintReadOnlyTextBoxStyle, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyCanSelectText, setReadOnlyControlStyle, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setReadOnlyWhen, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRequiredRightTitlePrefix, setRequiredRightTitleSuffix, setRequiredTitlePrefix, setRequiredTitleSuffix, setRequiredWhen, setRightTitlePrefix, setRightTitleSuffix, setRowSpan, setSaveOnEnter, setScClassName, setSelectOnClick, setSelectOnFocus, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowDisabledIconsOnFocus, setShowDisabledPickerIconOnFocus, setShowErrorIcon, setShowErrorIconInline, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIconsOnFocus, setShowIfCondition, setShowImageAsURL, setShowOldValueInHover, setShowOver, setShowOverIcons, setShowPending, setShowPickerIcon, setShowPickerIconOnFocus, setShowPickerOnFocus, setShowPickerOnFocusDelay, setShowRTL, setShowTitle, setShowValueIconOnly, setShowVoiceAssistIcon, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setStoreDisplayValues, setSupportsCutPasteEvents, setSuppressOptionDSFallback, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextBoxVPad, setTextFormula, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitlePrefix, setTitleStyle, setTitleSuffix, setTitleVAlign, setTooltip, setTop, setTreatEmptyAsNull, setType, setUpdateControlOnOver, setUpdatePickerIconOnOver, setUpdateTextBoxOnOver, setUseAdvancedCriteria, setUseDisabledHintStyleForReadOnly, setUseLocalDisplayFieldValue, setUseObjectFactoryForTypeFallback, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueByDisplayValue, setValueByDisplayValue, setValueDeselectedCSSText, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconAriaRole, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setVisibleWhen, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapHintText, setWrapStaticValue, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, storeValue, updateState, validate, valueClipped`

  ### Methods inherited from class com.smartgwt.client.data.Field

  `getCanExport, getExportTitle, getPrimaryKey, getSortByField, setCanExport, setExportTitle, setPrimaryKey, setSortByField`

  ### Methods inherited from class com.smartgwt.client.core.RefDataClass

  `getRef, getRef, internalSetID`

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### MiniDateRangeItem

    public MiniDateRangeItem()

  - ### MiniDateRangeItem

    public MiniDateRangeItem(JavaScriptObject jsObj)

  - ### MiniDateRangeItem

    public MiniDateRangeItem(String name)

  - ### MiniDateRangeItem

    public MiniDateRangeItem(String name, String title)

- ## Method Details

  - ### getOrCreateRef

    public static MiniDateRangeItem getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changePickerIconDefaults

    public static void changePickerIconDefaults(FormItemIcon defaults)

  - ### setAllowRelativeDates

    public MiniDateRangeItem setAllowRelativeDates(Boolean allowRelativeDates)
    Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
    Parameters:
      `allowRelativeDates` - New allowRelativeDates value. Default value is true
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getAllowRelativeDates

    public Boolean getAllowRelativeDates()
    Whether the `DateRangeDialog` opened when the `pickerIcon` is clicked should display `RelativeDateItem`s or `DateItem`s.
    Returns:
      Current allowRelativeDates value. Default value is true

  - ### setAutoValidate

    public MiniDateRangeItem setAutoValidate(Boolean autoValidate)
    If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
    If this method is called after the component has been drawn/initialized: Setter for `autoValidate`
    Parameters:
      `autoValidate` - New auto-validate setting. Default value is true
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getAutoValidate

    public Boolean getAutoValidate()
    If this attribute is set to true, the pop up date range dialog will automatically validate the user-entered "to" and "from" values on `"OK"`-click, and refuse to dismiss if these items contain invalid values.
    Returns:
      Current autoValidate value. Default value is true

  - ### setCanFocus

    public MiniDateRangeItem setCanFocus(Boolean canFocus)
    MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog. Set canFocus to false to suppress this behavior.
    Overrides:
      `setCanFocus` in class `FormItem`
    Parameters:
      `canFocus` - New canFocus value. Default value is true
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls
    See Also:
      - `Focus`

  - ### getCanFocus

    public Boolean getCanFocus()
    MiniDateRangeItems are marked as canFocus:true, and set up with properties such that focus will always go to the icon to launch the dateRange dialog. Set canFocus to false to suppress this behavior.
    Overrides:
      `getCanFocus` in class `FormItem`
    Returns:
      Current canFocus value. Default value is true
    See Also:
      - `Focus`

  - ### setCanTabToIcons

    public MiniDateRangeItem setCanTabToIcons(Boolean canTabToIcons)
    MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element. `canTabToIcons` is overridden to achieve this even if the property has been set to `false` at the `form level`.

    Note : This is an advanced setting

    Overrides:
      `setCanTabToIcons` in class `FormItem`
    Parameters:
      `canTabToIcons` - New canTabToIcons value. Default value is true
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getCanTabToIcons

    public Boolean getCanTabToIcons()
    MiniDateRangeItems rely on their icon being able to receive focus for normal user interaction as they have no other focusable element. `canTabToIcons` is overridden to achieve this even if the property has been set to `false` at the `form level`.
    Overrides:
      `getCanTabToIcons` in class `FormItem`
    Returns:
      Current canTabToIcons value. Default value is true

  - ### setDateDisplayFormat

    public MiniDateRangeItem setDateDisplayFormat(DateDisplayFormat dateDisplayFormat)
    Format for displaying dates to the user.

    If this attribute is unset, the display value is formatted intelligently according to the dates involved. For example, if both dates appear in the same month, the value will be formatted as

    `Month date1 - date2, Year`

    and, if in different months of the same year,

    `Month1 date1 - Month2 date2, Year`.

    If either date-value is unset, the display-value is formatted according to `fromDateOnlyPrefix` and `toDateOnlyPrefix`.

    Parameters:
      `dateDisplayFormat` - New dateDisplayFormat value. Default value is null
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getDateDisplayFormat

    public DateDisplayFormat getDateDisplayFormat()
    Format for displaying dates to the user.

    If this attribute is unset, the display value is formatted intelligently according to the dates involved. For example, if both dates appear in the same month, the value will be formatted as

    `Month date1 - date2, Year`

    and, if in different months of the same year,

    `Month1 date1 - Month2 date2, Year`.

    If either date-value is unset, the display-value is formatted according to `fromDateOnlyPrefix` and `toDateOnlyPrefix`.

    Returns:
      Current dateDisplayFormat value. Default value is null

  - ### setFromDateOnlyPrefix

    public MiniDateRangeItem setFromDateOnlyPrefix(String fromDateOnlyPrefix)
    The text to prepend to the formatted date when only a `fromDate` is supplied.
    Parameters:
      `fromDateOnlyPrefix` - New fromDateOnlyPrefix value. Default value is "Since"
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getFromDateOnlyPrefix

    public String getFromDateOnlyPrefix()
    The text to prepend to the formatted date when only a `fromDate` is supplied.
    Returns:
      Current fromDateOnlyPrefix value. Default value is "Since"

  - ### setPickerIcon

    public MiniDateRangeItem setPickerIcon(FormItemIcon pickerIcon)
    Icon that launches a `DateChooser` for choosing an absolute date.
    Parameters:
      `pickerIcon` - New pickerIcon value. Default value is null
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getPickerIcon

    public FormItemIcon getPickerIcon()
    Icon that launches a `DateChooser` for choosing an absolute date.
    Returns:
      Current pickerIcon value. Default value is null

  - ### setPickerIconPrompt

    public MiniDateRangeItem setPickerIconPrompt(String pickerIconPrompt)
    The prompt to show when the mouse is hovered over the `pickerIcon`.
    Overrides:
      `setPickerIconPrompt` in class `FormItem`
    Parameters:
      `pickerIconPrompt` - New pickerIconPrompt value. Default value is "Show Date Chooser"
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls
    See Also:
      - `HTMLString`

  - ### getPickerIconPrompt

    public String getPickerIconPrompt()
    The prompt to show when the mouse is hovered over the `pickerIcon`.
    Overrides:
      `getPickerIconPrompt` in class `FormItem`
    Returns:
      Current pickerIconPrompt value. Default value is "Show Date Chooser"
    See Also:
      - `HTMLString`

  - ### getRangeDialog

    public DateRangeDialog getRangeDialog()
    Pop-up `DateRangeDialog` for entering a date range.

    This component is an AutoChild named "rangeDialog". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current rangeDialog value. Default value is null

  - ### setShouldSaveValue

    public MiniDateRangeItem setShouldSaveValue(Boolean shouldSaveValue)
    Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
    Overrides:
      `setShouldSaveValue` in class `FormItem`
    Parameters:
      `shouldSaveValue` - New shouldSaveValue value. Default value is true
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getShouldSaveValue

    public Boolean getShouldSaveValue()
    Allow miniDateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
    Overrides:
      `getShouldSaveValue` in class `FormItem`
    Returns:
      Current shouldSaveValue value. Default value is true

  - ### setTextBoxStyle

    public MiniDateRangeItem setTextBoxStyle(String textBoxStyle)
    Base CSS class name for a form item's text box element.

    See `FormItemStyling` for an overview of formItem styling, and the `CompoundFormItem_skinning` discussion for special skinning considerations.

    If the `textBoxStyle` is changed at runtime, `updateState()` must be called to update the visual state of this item.

    Overrides:
      `setTextBoxStyle` in class `StaticTextItem`
    Parameters:
      `textBoxStyle` - New textBoxStyle value. Default value is "textItem"
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls
    See Also:
      - `FormItem.setCellStyle(java.lang.String)`
      - `FormItemBaseStyle`
      - `FormItem Styling`

  - ### getTextBoxStyle

    public String getTextBoxStyle()
    Base CSS class name for a form item's text box element.

    See `FormItemStyling` for an overview of formItem styling, and the `CompoundFormItem_skinning` discussion for special skinning considerations.

    If the `textBoxStyle` is changed at runtime, `updateState()` must be called to update the visual state of this item.

    Overrides:
      `getTextBoxStyle` in class `StaticTextItem`
    Returns:
      Current textBoxStyle value. Default value is "textItem"
    See Also:
      - `FormItem.getCellStyle()`
      - `FormItemBaseStyle`
      - `FormItem Styling`

  - ### setToDateOnlyPrefix

    public MiniDateRangeItem setToDateOnlyPrefix(String toDateOnlyPrefix)
    The text to prepend to the formatted date when only a `toDate` is supplied.
    Parameters:
      `toDateOnlyPrefix` - New toDateOnlyPrefix value. Default value is "Before"
    Returns:
      `MiniDateRangeItem` instance, for chaining setter calls

  - ### getToDateOnlyPrefix

    public String getToDateOnlyPrefix()
    The text to prepend to the formatted date when only a `toDate` is supplied.
    Returns:
      Current toDateOnlyPrefix value. Default value is "Before"

  - ### hasAdvancedCriteria

    public Boolean hasAdvancedCriteria()
    Overridden to return true: dateRangeItems always generate AdvancedCriteria.
    Overrides:
      `hasAdvancedCriteria` in class `FormItem`
    Returns:
      true
    See Also:
      - `Criteria Editing`

  - ### setDefaultProperties

    public static void setDefaultProperties(MiniDateRangeItem miniDateRangeItemProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `miniDateRangeItemProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setFromDate

    public void setFromDate(Date fromDate)
    Initial value for the "from" date. Sets the `fromDate` for this DateRangeItem.
    Parameters:
      `fromDate` - the date from which this item should start it's range. Default value is today

  - ### getFromDate

    public Date getFromDate()
    Initial value for the "from" date.
    Returns:
      java.util.Date

  - ### setToDate

    public void setToDate(Date toDate)
    Initial value for the "to" date. Sets the `toDate` for this DateRangeItem.
    Parameters:
      `toDate` - the date at which this item should end it's range. Default value is today

  - ### getToDate

    public Date getToDate()
    Initial value for the "to" date.
    Returns:
      java.util.Date

  - ### getValue

    public DateRange getValue()
    Retrieves the current value of this dateRangeItem. The return value is a `DateRange` object that excludes start and end values if they aren't set.
    Overrides:
      `getValue` in class `FormItem`
    Returns:
      the current value of this item

  - ### setValue

    public void setValue(DateRange value)
    Sets the value for this dateRangeItem. The value parameter is a `DateRange` object that optionally includes both start and end values.
    Parameters:
      `value` - the new value for this item

  - ### setCriterionGetter

    public void setCriterionGetter(FormItemCriterionGetter getter)
    The default `getCriterion()` implementation returns the Criterion entered in the fields shown in the `rangeDialog`.

    If both dates are entered, a Criterion with an "and" `operator` and both "greaterOrEqual" and "lessOrEqual" sub-criteria will be returned. If either date is omitted, only the "greaterOrEqual" (from date) or "lessOrEqual" (to date) Criterion is returned.

    Overrides:
      `setCriterionGetter` in class `FormItem`
    Parameters:
      `getter` - provides a method to get a criterion object based on this field's current edited value(s).
    See Also:
      - `FormItem.setCriterionGetter(com.smartgwt.client.widgets.form.FormItemCriterionGetter)`
      - `CriteriaEditing overview and related methods`